<?php

//load the text file into a variable
$test= file_get_contents("test.txt" );


//Function to split HTML into chunks of a given length
//Function to split HTML into chunks of a given length
function wp_auto_spinner_split_text($article, $char_count)
{

    $chunks = array();
    $remeaning_text = $article;
	$mbstring_is_installed = true;

	//check if function mb_substr not exists and if it is not, log that and ask the user to install mbstring module
	if (!function_exists('mb_substr')) {
		wp_auto_spinner_log_new('WARNING!!!!', 'mbstring module is not installed on your server. Please install it to be able to use the plugin.');
		$mbstring_is_installed = false;
	}

    while ($remeaning_text != "") {

        //get a chunk
        if($mbstring_is_installed){
			$chunk = mb_substr($remeaning_text, 0, $char_count); 
		}else{
			$chunk = substr($remeaning_text, 0, $char_count);
		}

        //remaining text
		if($mbstring_is_installed){
	        $remeaning_text = mb_substr($remeaning_text, $char_count);
		}else{
			$remeaning_text = substr($remeaning_text, $char_count);
		}

        //preg match <[^>]*$
        preg_match("{<[^>]*$}s", $chunk, $matches);

        //unclosed tag
        $found_unclosed_tag = $matches[0];

        //if not empty, remove it from the chunk and add it to the remeaning text
        if ($found_unclosed_tag != "") {

            //remove found_unclosed_tag from the chunk using str_replace
            $chunk = preg_replace("{<[^>]*$}s", "", $chunk);

            //add the found_unclosed_tag to the remeaning text
            $remeaning_text = $found_unclosed_tag . $remeaning_text;

        }else{
            //check if a word was truncated between the chunk and the remeaning text
            //if the last charachter of the chunk is not a space and the first char of the remaining text then a word was truncated
            //to correct that case we should take the first word of the remaining text and add it to the chunk
            if ($chunk[strlen($chunk) - 1] != " " && $remeaning_text[0] != " ") {

                //get the first word of the remaining text
                preg_match("{^[^ ]*}s", $remeaning_text, $matches);

                //add the first word of the remaining text to the chunk
                $chunk .= $matches[0];

                //remove the first word of the remaining text
                $remeaning_text = preg_replace("{^[^ ]*}s", "", $remeaning_text);

            }
        }
        $chunks[] = $chunk;

    }

	//if number of chunks is more than 1 and the last chunk is too small in size, we can merge it with the previous chunk
	//the chunk is regarded small if it is less than 30% of the char_count
	if(count($chunks) > 1){
		$last_chunk = $chunks[count($chunks) - 1];
		$last_chunk_size = strlen($last_chunk); 
		$min_chunk_size = $char_count * 0.3;

		if($last_chunk_size < $min_chunk_size){
			$chunks[count($chunks) - 2] .= $last_chunk;
			unset($chunks[count($chunks) - 1]);
		}
	}

    return $chunks;


}
    
$chunks = wp_auto_spinner_split_text($test , 1000);

print_r($chunks);